/* Customize from here downwards */
jQuery(document).ready( function($) {
	//TODO some backwards compatability here -
	if( $('#LoginWithAjax').length > 0 ){
		$('#LoginWithAjax').addClass('lwa');
		$('#LoginWithAjax_Status').addClass('lwa-status');
		$('#LoginWithAjax_Register').addClass('lwa-register');
		$('#LoginWithAjax_Remember').addClass('lwa-remember');
		$('#LoginWithAjax_Links_Remember').addClass('lwa-links-remember');
		$('#LoginWithAjax_Links_Remember_Cancel').addClass('lwa-links-remember-cancel');
		$('#LoginWithAjax_Form').addClass('lwa-form');
	}
	/*
	 * links
	 * add action input htmls
	 */
	//Remember and register form AJAX
 	$('form.lwa-form, form.lwa-remember, div.lwa-register form').submit(function(event){
		//Stop event, add loading pic...
 		event.preventDefault();
 		var form = $(this);
 		var statusElement = form.find('.lwa-status');
 		if( statusElement.length == 0 ){
 			statusElement = $('<span class="lwa-status"></span>');
 			form.prepend(statusElement);
 		}
		$('<div class="lwa-loading"></div>').prependTo(form);
		//Make Ajax Call
		$.post(form.attr('action'), form.serialize(), function(data){
			lwaAjax( data, statusElement );
			$(document).trigger('lwa_' + data.action, [data, form]);
		}, "jsonp");
		//trigger event
	});
 	
 	//Catch login actions
 	$(document).on('lwa_login', function(event, data, form){
		if(data.result === true){
			//Login Successful - Extra stuff to do
			if( data.widget != null ){
				$.get( data.widget, function(widget_result) {
					var newWidget = $(widget_result); 
					form.parent('.lwa').replaceWith(newWidget);
					var lwaSub = newWidget.find('.').show();
					var lwaOrg = newWidget.parent().find('.lwa-title');
					lwaOrg.replaceWith(lwaSub);
				});
			}else{
				if(data.redirect == null){
					window.location.reload();
				}else{
					window.location = data.redirect;
				}
			}
		}
 	});
 	
	//Registration overlay
 	$('.lwa-modal').each( function(i,e){
 		var modal = $(e);
 		modal.parents('.lwa').data('modal', modal);
 		$('body').append($('<div class="lwa"></div>').append(modal));
 	});
	$(document).on('click', ".lwa-links-modal",  function(e){
		e.preventDefault();
		target = $(this).parents('.lwa').data('modal');
		target.reveal({
			 modalbgclass: 'lwa-modal-bg',
		     dismissmodalclass: 'lwa-modal-close'    //the class of a button or element that will close an open modal
		});
	});	
	//Register
	$('.lwa-links-register-inline').click(function(event){
		event.preventDefault();
		$(this).parents('.lwa').find('.lwa-register').show('slow');
	});
	$('.lwa-links-register-inline-cancel').click(function(event){
		event.preventDefault();
		$(this).parents('.lwa-register').hide('slow');
	});
 	
	//Visual Effects for hidden items
	//Remember
	$(document).on('click', '.lwa-links-remember', function(event){
		event.preventDefault();
		$(this).parents('.lwa').find('.lwa-remember').show('slow');
	});
	$(document).on('click', '.lwa-links-remember-cancel', function(event){
		event.preventDefault();
		$(this).parents('.lwa-remember').hide('slow');
	});
	
	//Handle a AJAX call for Login, RememberMe or Registration
	function lwaAjax( data, statusElement ){
		$('.lwa-loading').remove();
		statusElement = $(statusElement);
		if(data.result === true){
			//Login Successful
			statusElement.attr('class','lwa-status lwa-status-confirm').html(data.message); //modify status content
		}else if( data.result === false ){
			//Login Failed
			statusElement.attr('class','lwa-status lwa-status-invalid').html(data.error); //modify status content
			//We assume a link in the status message is for a forgotten password
			statusElement.find('a').click(function(event){
				event.preventDefault();
				$(this).parents('.lwa').find('form.lwa-remember').show('slow');
			});
		}else{	
			//If there already is an error element, replace text contents, otherwise create a new one and insert it
			statusElement.attr('class','lwa-status lwa-status-invalid').html('An error has occured. Please try again.'); //modify status content
		}
	}

});

/* Do not edit after here*/
/* http://zurb.com/playground/reveal-modal-plugin */
(function(e){e("a[data-reveal-id]").on("click",function(t){t.preventDefault();var n=e(this).attr("data-reveal-id");e("#"+n).reveal(e(this).data())});e.fn.reveal=function(t){var n={animation:"fadeAndPop",animationspeed:300,closeonbackgroundclick:true,dismissmodalclass:"close-reveal-modal",modalbgclass:"reveal-modal-bg"};var t=e.extend({},n,t);return this.each(function(){function a(){s=false}function f(){s=true}var n=e(this),r=parseInt(n.css("top")),i=n.height()+r,s=false,o=e("."+t.modalbgclass);if(o.length==0){o=e('<div class="'+t.modalbgclass+'" />').insertAfter(n)}if(n.find("."+t.dismissmodalclass).length==0){n.append('<a class="'+t.dismissmodalclass+'">&#215;</a>')}n.bind("reveal:open",function(){o.unbind("click.modalEvent");e("."+t.dismissmodalclass).unbind("click.modalEvent");if(!s){f();if(t.animation=="fadeAndPop"){n.css({top:e(document).scrollTop()-i,opacity:0,visibility:"visible",display:"block"});o.fadeIn(t.animationspeed/2);n.delay(t.animationspeed/2).animate({top:e(document).scrollTop()+r+"px",opacity:1},t.animationspeed,a())}if(t.animation=="fade"){n.css({opacity:0,visibility:"visible",top:e(document).scrollTop()+r,display:"block"});o.fadeIn(t.animationspeed/2);n.delay(t.animationspeed/2).animate({opacity:1},t.animationspeed,a())}if(t.animation=="none"){n.css({visibility:"visible",top:e(document).scrollTop()+r,display:"block"});o.css({display:"block"});a()}}n.unbind("reveal:open")});n.bind("reveal:close",function(){if(!s){f();if(t.animation=="fadeAndPop"){o.delay(t.animationspeed).fadeOut(t.animationspeed);n.animate({top:e(document).scrollTop()-i+"px",opacity:0},t.animationspeed/2,function(){n.css({top:r,opacity:1,visibility:"hidden"});a()})}if(t.animation=="fade"){o.delay(t.animationspeed).fadeOut(t.animationspeed);n.animate({opacity:0},t.animationspeed,function(){n.css({opacity:1,visibility:"hidden",top:r});a()})}if(t.animation=="none"){n.css({visibility:"hidden",top:r});o.css({display:"none"})}}n.unbind("reveal:close")});n.trigger("reveal:open");var u=e("."+t.dismissmodalclass).bind("click.modalEvent",function(){n.trigger("reveal:close")});if(t.closeonbackgroundclick){o.css({cursor:"pointer"});o.bind("click.modalEvent",function(){n.trigger("reveal:close")})}e("body").keyup(function(e){if(e.which===27){n.trigger("reveal:close")}})})}})(jQuery)